// An illustration of  simple sequencing exercise

#include <stdlib.h>		// Libraries which may be needed
#include <stdio.h>
#include <unistd.h>
#include <signal.h>

struct sigaction sigaction_structure;	// A data structure, filled in below
				// Used to trap incoming signals
void murdered();

/*----------------------------------------------------------------------------*/

int main (int argc, char *argv[])	// The 'root' programme; execution start
{
  pid_t new_PID;			// PID return value from fork
  int i;

  printf("Hello from %s ", argv[0]);// My name
  printf("with PID %d ", getpid()); // My Unix identity
  printf("whose parent is %d\n", getppid()); // My mum's PID

  new_PID = fork();		// The call we are exercising

  if (new_PID != 0)		// Parent runs this branch
    {
    int status;			// A place for status return

    printf("I now have a child %d\n", new_PID);

    sleep(1);			// Wait a little
/*
    printf("Signal to child %d.\n", new_PID);
    kill(new_PID, SIGTERM);	// A heinous act?
*/
    waitpid(new_PID, &status, 0);// Wait for child state change
    printf("\nChild %d has exited ", new_PID);
    if (status == 0) printf("normally.\n");
    else             printf("badly.\n");

    }//if

  else				// Child runs this branch

    {
    // Set three fields in a predefined 'struct'
    sigaction_structure.sa_handler = &murdered;	// Pointer to a -function-
    sigemptyset(&sigaction_structure.sa_mask);	// Call defines 'empty' field
    sigaction_structure.sa_flags   = 0;		// No flags

    // Link the structure to signal "SIGINT" (as generated by ^C)
    sigaction(SIGTERM, &sigaction_structure, NULL);	// Link

    printf("I am %d, child of %d\n", getpid(), getppid());

    while (1 == 1) ;		// Immortality?
    }//else


  printf("\nGoodbye from %s with PID %d\n", argv[0], getpid());

  exit(0);			// A way of stopping this process
				// The '0' indicates "okay"
}//main


//------------------------------------------------------------------------------

void murdered(int signum)
{
  printf("\nProlicide!!\n");

  exit(1);			// Bad end!
}//murdered

//------------------------------------------------------------------------------
